#! /bin/sh

TARGET="/mnt/mtd/ipc"
CONF="$TARGET/conf"
CONF_PATH=/mnt/mtd/ipc/tmpfs
FLAG_PATH=$CONF_PATH/wifires
NETDEV=ra0
wifidev=ra0
wifi_res=1
WFSEC=4

checkwifi()
{
. $CONF_PATH/wifi.conf

	wifi_res=0
	if [[ $WifiEnc = "NONE" ]] || [[ $WifiEnc = "WEP" ]]
	then
		sleep 2
		for i in $(seq 6)
		do
			sleep 0.5
			if ! iwconfig $wifidev | grep "Access Point:"
			then
				wifi_res=1
				break			
			fi
		done		
	else
		if ! iwconfig $wifidev | grep "Security mode:"
		then
			wifi_res=1
			break			
		fi	
	fi
}

loadwifitmp()
{
. $CONF_PATH/wifi.conf

	iwpriv $NETDEV set AuthMode=$WifiMode
	iwpriv $NETDEV set NetworkType=Infra
	iwpriv $NETDEV set EncrypType=$WifiEnc
	if [ $WifiEnc != "NONE" ]
	then	
		if [ $WifiEnc == "WEP" ]
		then
			iwpriv $NETDEV set DefaultKeyID=1
			iwpriv $NETDEV set Key1="$WifiKey"
		else
			iwpriv $NETDEV set WPAPSK="$WifiKey"
		fi
	fi
	iwpriv $NETDEV set SSID="$WifiSsid"
	sleep $WFSEC
	checkwifi
}

loadwificonf()
{
. $CONF/wifi.conf

	iwpriv $NETDEV set AuthMode=$WifiMode
	iwpriv $NETDEV set NetworkType=Infra
	iwpriv $NETDEV set EncrypType=$WifiEnc
	if [ $WifiEnc != "NONE" ]
	then	
		if [ $WifiEnc == "WEP" ]
		then
			iwpriv $NETDEV set DefaultKeyID=1
			iwpriv $NETDEV set Key1="$WifiKey"
		else
			iwpriv $NETDEV set WPAPSK="$WifiKey"
		fi
	fi
	iwpriv $NETDEV set SSID="$WifiSsid"
}

chkap()
{
. $CONF/wifi.conf
	if [ $WifiType = "Adhoc" ]
	then
		touch $FLAG_PATH
		exit 0
	fi	
}

rm $FLAG_PATH
chkap
NETFLAG=`cat $TARGET/tmpfs/netflag.dat`
if [ $NETFLAG -eq 1 ]
then
	GATEWAY=`route | grep default | awk -F " " '{printf $2}'`
	ifconfig $wifidev down
	WFSEC=6
fi
ifconfig $wifidev up
loadwifitmp
if [ $NETFLAG -eq 0 ]
then
	iwpriv $wifidev set SSID=""
else
	ifconfig $wifidev down
	ifconfig $wifidev up
	loadwificonf
	route add default gw $GATEWAY
fi
if [ $wifi_res -eq 0 ]
then
	touch $FLAG_PATH
fi
